Viewporter = CreateFrame("Frame")
local _ = _
local self = Viewporter
SLASH_VIEWPORTER1, SLASH_VIEWPORTER2, SLASH_VIEWPORTER3 = "/vp", "/viewporter", "/viewport";

--viewport setting code stolen from Electroflux Textronator
function self:setViewport()
	if not self.db.enabled then return end
	local scale = 768 / UIParent:GetHeight()

	WorldFrame:SetPoint("TOPLEFT", 0, -( self.db.top * scale) )
	WorldFrame:SetPoint("BOTTOMRIGHT", 0, (self.db.bottom * scale) )
end

function self:onLoad( event, name )
	self.db = ViewporterDB or {
		enabled = true,
		top = 0,
		bottom = 0,
		firsttime = true
	}
	ViewporterDB = self.db

	if self.db.firsttime then
		print("Viewporter by sztanpet loaded. /vp for help")
		self.db.firsttime = false
	end	

	self:setViewport()
end

function self.onChatCommand( msg )
	local _, _, command, value = string.find( msg, "^(%S*)%s*(.-)$")
	
	if command == "enable" then
		self.db.enabled = true
	elseif command == "disable" then
		self.db.enabled = false
	elseif command == "reset" then
		self.db.top = 0
		self.db.bottom = 0
	elseif ( command == "top" or command == "bottom" ) and tonumber( value ) then
		self.db[ command ] = value
	else
		return print("Viewporter: invalid or empty command, try enable/disable/reset or top/bottom with a number argument, for example /vp top 10")
	end

	self:setViewport()
end

SlashCmdList["VIEWPORTER"] = self.onChatCommand;
self:SetScript("OnEvent", self.onLoad )
self:RegisterEvent("VARIABLES_LOADED")
